
#include "semaphore.h"
#include "BoundedBuffer.h"
#include <string>
#include <vector>

void BoundedBuffer::push(string item){
    
    empty->P();
    mutex->P();
    data.push_back(item);
    mutex->V();
    full->V();//increment the number of full slots now.
}

string BoundedBuffer::pop(){
    string item = data.back();
	full->P();
    mutex->P();
	data.pop_back();
    mutex->V();
	empty->V();
    return item;
}
    